// =========================== F28335 semaphore TEST ========================
//  CPU : TMS320F28335-150M
//     ¥ : 2009-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : CCS3.3
// [ ]  : OSC 30M -> 30*10 / 2 = 150M
//            COM1Ʈ ̿ semaphore TEST α׷(115200,N,8,1)
// ----------------------------------------------------------------------------
#include "DSP2833x_Device.h"					// Peripheral address definitions
#include "DSP2833x_main.h"					// Main include file

//  
unsigned char com1_rx_data;					// COM1  ͷƮ  fifo

// ===============================  α׷ ==============================
// [μ] void
// ---------------------------------------------------------------------------
void main(void)
{
	InitSysCtrl();						// Initialize the CPU
	InitPieCtrl();						// Initialize and enable the PIE
	InitWatchdog();						// Initialize the Watchdog Timer
	InitGpio();							// Initialize the shared GPIO pins
	InitXintf();						// Initialize the external memory interface

// Copy all Flash sections that need to run from RAM (use memcpy() from RTS library)
// Section secureRamFuncs contains user defined code that runs from CSM secured RAM
	memcpy(	&secureRamFuncs_runstart,&secureRamFuncs_loadstart,&secureRamFuncs_loadend - &secureRamFuncs_loadstart);
// Initialize the Flash and OTP
	InitFlash();						// Initialize the Flash
	com_init(_COM1,115200L,NON_P,8,1);			// COM1 

	asm(" EALLOW");						// Enable EALLOW protected register access
	GpioCtrlRegs.GPBMUX1.bit.GPIO32 = 0;			// GPIO032 GPIO
	GpioCtrlRegs.GPBDIR.bit.GPIO32 = 1;			// GPIO32  output
	GpioDataRegs.GPBSET.bit.GPIO32 = 1;			// GPIO32 pin is set to 1
 	asm(" EDIS");						// Disable EALLOW protected register access

// Enable interrupts
	SetDBGIER(IER | 0x6000);				// Enable everything in IER, plus TINT2 and DLOGINT
	*(volatile unsigned int *)0x00000C14 |= 0x0C00;		// Set TIMER2 FREE=SOFT=1
// main()  ϸ DSP/BIOS ..

}

// ================================ UserInit =================================
// [μ] void
// [] Description: This is the user initialization file to be specified in
//	  the DSP/BIOS configuration file, System - Global Settings.
// ---------------------------------------------------------------------------
void UserInit(void)
{
// Section .trcdata is generated by DSP/BIOS.
// It must be copied from its load to its run address BEFORE main().
	memcpy(&trcdata_runstart, &trcdata_loadstart, &trcdata_loadend - &trcdata_loadstart);
}

// ==================================== TASK1 =========================
// [μ] void
// --------------------------------------------------------------------
void task1_proc(void)
{
	while(1) {
		SEM_pend(&sem_com1_rx_eflg,SYS_FOREVER);
		com1_putch(com1_rx_data);			//  ۽
	}
}

// ============================== PRD0 ٷ =======================
// [μ] void
// [] DSP/BIOS 500ms  Ÿ
// --------------------------------------------------------------------
void Io_Blink(void)
{
static Uint16 gpio_count = 0;					// Used for LOG_printf
	
// Show an example of using LOG_printf() to write to a log buffer
	LOG_printf(&trace, "GPIO_Blink Count = %u", gpio_count++);
	
	GpioDataRegs.GPBTOGGLE.bit.GPIO32 = 1;			// Toggle the pin
}

// ============================ COM1 RX ͷƮ ======================
// [μ] void
// --------------------------------------------------------------------
void Uart1_RxSwi(void)
{
int i,rsr,len;

	rsr = SciaRegs.SCIRXST.all & 0xff;			// rsr read  
	if((rsr & 0x9c) != 0){
	    SciaRegs.SCICTL1.bit.SWRESET=0;			// reset
	    SciaRegs.SCICTL1.bit.SWRESET=1;			// non reset
	}	           
	else{
		len = (SciaRegs.SCIFFRX.all >> 8) & 0x1f;
		for(i = 0; i < len; i++){
			com1_rx_data = SciaRegs.SCIRXBUF.all;
			SEM_post(&sem_com1_rx_eflg);
		}   			
 	} 
	SciaRegs.SCIFFRX.bit.RXFFOVRCLR=1; 			// Clear Overflow flag
	SciaRegs.SCIFFRX.bit.RXFFINTCLR=1; 			// Clear Interrupt flag
}
